import { renderless, api } from '@opentinyvue/vue-renderless/year-range/vue';
import { defineComponent, directive, props, setup } from '@opentinyvue/vue-common';
import { Clickoutside } from '@opentinyvue/vue-directive';
import YearTable from '@opentinyvue/vue-year-table';
import { IconDoubleRight, IconDoubleLeft } from '@opentinyvue/vue-icon';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var render = function render2() {
  var _vm$state$shortcuts;
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("transition", {
    attrs: {
      "name": "tiny-zoom-in-top"
    },
    on: {
      "after-leave": function afterLeave($event) {
        return _vm.$emit("dodestroy");
      }
    }
  }, [_c("div", {
    staticClass: "tiny-picker-panel tiny-date-range-picker tiny-popper",
    class: [{
      "has-sidebar": _vm.slots.sidebar || _vm.state.shortcuts
    }, _vm.state.popperClass]
  }, [_c("div", {
    staticClass: "tiny-picker-panel__body-wrapper"
  }, [_vm._t("sidebar"), (_vm$state$shortcuts = _vm.state.shortcuts) !== null && _vm$state$shortcuts !== void 0 && _vm$state$shortcuts.length ? _c("div", {
    staticClass: "tiny-picker-panel__sidebar"
  }, _vm._l(_vm.state.shortcuts, function(shortcut, idx) {
    return _c("button", {
      key: idx,
      staticClass: "tiny-picker-panel__shortcut",
      attrs: {
        "type": "button",
        "title": shortcut.text
      },
      on: {
        "click": function click($event) {
          return _vm.handleShortcutClick(shortcut);
        }
      }
    }, [_vm._v(" " + _vm._s(shortcut.text) + " ")]);
  }), 0) : _vm._e(), _c("div", {
    staticClass: "tiny-picker-panel__body"
  }, [_c("div", {
    staticClass: "tiny-picker-panel__content tiny-date-range-picker__content is-left"
  }, [_c("div", {
    staticClass: "tiny-date-range-picker__header"
  }, [_c("button", {
    staticClass: "tiny-picker-panel__icon-btn tiny-icon-d-arrow-left",
    attrs: {
      "type": "button"
    },
    on: {
      "click": _vm.leftPrevYear
    }
  }, [_c("icon-double-left")], 1), _vm.unlinkPanels ? _c("button", {
    staticClass: "tiny-picker-panel__icon-btn tiny-icon-d-arrow-right",
    class: {
      "is-disabled": !_vm.state.enableYearArrow
    },
    attrs: {
      "type": "button",
      "disabled": !_vm.state.enableYearArrow
    },
    on: {
      "click": _vm.leftNextYear
    }
  }, [_c("icon-double-right")], 1) : _vm._e(), _c("div", [_vm._v(_vm._s(_vm.state.leftLabel))])]), _c("div", {
    staticClass: "tiny-date-range-picker__table"
  }, [_c("year-table", {
    ref: "leftYearTable",
    attrs: {
      "selection-mode": _vm.state.selectionMode,
      "date": _vm.state.leftDate,
      "default-value": _vm.state.defaultValue,
      "min-date": _vm.state.minDate,
      "max-date": _vm.state.maxDate,
      "range-state": _vm.state.rangeState,
      "disabled-date": _vm.state.disabledDate,
      "start-year": _vm.state.leftStartYear,
      "readonly": _vm.readonly
    },
    on: {
      "changerange": _vm.handleChangeRange,
      "pick": _vm.handleRangePick
    }
  })], 1)]), _c("div", {
    staticClass: "tiny-picker-panel__content tiny-date-range-picker__content is-right"
  }, [_c("div", {
    staticClass: "tiny-date-range-picker__header"
  }, [_vm.unlinkPanels ? _c("button", {
    staticClass: "tiny-picker-panel__icon-btn tiny-icon-d-arrow-left",
    class: {
      "is-disabled": !_vm.state.enableYearArrow
    },
    attrs: {
      "type": "button",
      "disabled": !_vm.state.enableYearArrow
    },
    on: {
      "click": _vm.rightPrevYear
    }
  }, [_c("icon-double-left")], 1) : _vm._e(), _c("button", {
    staticClass: "tiny-picker-panel__icon-btn tiny-icon-d-arrow-right",
    attrs: {
      "type": "button"
    },
    on: {
      "click": _vm.rightNextYear
    }
  }, [_c("icon-double-right")], 1), _c("div", [_vm._v(_vm._s(_vm.state.rightLabel))])]), _c("div", {
    staticClass: "tiny-date-range-picker__table"
  }, [_c("year-table", {
    ref: "rightRearTable",
    attrs: {
      "selection-mode": _vm.state.selectionMode,
      "date": _vm.state.rightDate,
      "default-value": _vm.state.defaultValue,
      "min-date": _vm.state.minDate,
      "max-date": _vm.state.maxDate,
      "range-state": _vm.state.rangeState,
      "disabled-date": _vm.state.disabledDate,
      "start-year": _vm.state.rightStartYear,
      "readonly": _vm.readonly
    },
    on: {
      "changerange": _vm.handleChangeRange,
      "pick": _vm.handleRangePick
    }
  })], 1)])])], 2)])]);
};
var staticRenderFns = [];
var __vue2_script = defineComponent({
  directives: directive({
    Clickoutside
  }),
  components: {
    YearTable,
    IconDoubleRight: IconDoubleRight(),
    IconDoubleLeft: IconDoubleLeft()
  },
  props: [].concat(props, ["emitter", "modelValue", "format", "readonly", "shortcuts", "disabledDate", "popperClass", "unlinkPanels"]),
  emits: ["dodestroy", "pick", "select-change", "update:modelValue"],
  setup: function setup$1(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var pc = /* @__PURE__ */ function() {
  return __component__.exports;
}();

export { pc as default };
